# Class OjNBoxBase

This is the base class for oj-n-box WebElement, and is generated from the component's metadata. Do not modify these contents since they'll be replaced during the next generation. Put overrides into the WebElements's subclass, OjNBox.ts.

#### Hierarchy

- OjWebElement
  - OjNBoxBase
    - OjNBox

#####
Index

### Constructors

constructor

### Methods

changeHiddenCategories
changeHighlightedCategories
changeMaximizedColumn
changeMaximizedRow
changeSelection
clear
click
findElement
findElements
getAnimationOnDataChange
getAnimationOnDisplay
getAs
getAttribute
getCellContent
getCellMaximize
getCells
getColumns
getColumnsTitle
getCountLabel
getCssValue
getDataTransferOptions
getDnd
getGroupAttributes
getGroupBehavior
getHiddenCategories
getHighlightMatch
getHighlightedCategories
getHoverBehavior
getLabelTruncation
getLocation
getMaximizedColumn
getMaximizedRow
getNodes
getOtherColor
getOtherThreshold
getProperty
getRect
getRows
getRowsTitle
getSelection
getSelectionMode
getSize
getStyleDefaults
getText
getTooltip
getTouchResponse
getTrackResize
getTranslations
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady

## Constructors

### constructor

- new OjNBoxBase(el, locators): OjNBoxBase

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjNBoxBase

  Inherited from OjWebElement.constructor

## Methods

### changeHiddenCategories

- changeHiddenCategories(hiddenCategories): Promise<void>

- Sets the value of `hiddenCategories` property. An array of category strings used for filtering. Data items with any category matching an item in this array will be filtered.

  #### Parameters

  - ##### hiddenCategories: string[]

    The value to set for `hiddenCategories`

  #### Returns Promise<void>

### changeHighlightedCategories

- changeHighlightedCategories(highlightedCategories): Promise<void>

- Sets the value of `highlightedCategories` property. An array of category strings used for highlighting. Data items matching categories in this array will be highlighted.

  #### Parameters

  - ##### highlightedCategories: string[]

    The value to set for `highlightedCategories`

  #### Returns Promise<void>

### changeMaximizedColumn

- changeMaximizedColumn(maximizedColumn): Promise<void>

- Sets the value of `maximizedColumn` property. The id of the column to be maximized.

  #### Parameters

  - ##### maximizedColumn: string

    The value to set for `maximizedColumn`

  #### Returns Promise<void>

### changeMaximizedRow

- changeMaximizedRow(maximizedRow): Promise<void>

- Sets the value of `maximizedRow` property. The id of the row to be maximized.

  #### Parameters

  - ##### maximizedRow: string

    The value to set for `maximizedRow`

  #### Returns Promise<void>

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. Specifies the ids of the selected nodes.

  #### Parameters

  - ##### selection: any[]

    The value to set for `selection`

  #### Returns Promise<void>

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.click

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from OjWebElement.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from OjWebElement.findElements

### getAnimationOnDataChange

- getAnimationOnDataChange(): Promise<string>

- Gets the value of `animationOnDataChange` property. Specifies the animation that is applied on data changes.

  #### Returns Promise<string>

  The value of `animationOnDataChange` property.

### getAnimationOnDisplay

- getAnimationOnDisplay(): Promise<string>

- Gets the value of `animationOnDisplay` property. Specifies the animation that is shown on initial display.

  #### Returns Promise<string>

  The value of `animationOnDisplay` property.

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. Specifies the alias for the current item when referenced inside the nodeTemplate.

  #### Returns Promise<string>

  The value of `as` property.

  #### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getAttribute

### getCellContent

- getCellContent(): Promise<string>

- Gets the value of `cellContent` property. Specifies the content displayed in cells. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `cellContent` property.

### getCellMaximize

- getCellMaximize(): Promise<string>

- Gets the value of `cellMaximize` property. Specifies whether cell maximize/de-maximize gestures are enabled.

  #### Returns Promise<string>

  The value of `cellMaximize` property.

### getCells

- getCells(): Promise<null | Cells[]>

- Gets the value of `cells` property. Specifies the list of cells. Also accepts a Promise for deferred data rendering.

  #### Returns Promise<null | Cells[]>

  The value of `cells` property.

### getColumns

- getColumns(): Promise<null | Columns[]>

- Gets the value of `columns` property. Specifies the list of columns. Also accepts a Promise for deferred data rendering.

  #### Returns Promise<null | Columns[]>

  The value of `columns` property.

### getColumnsTitle

- getColumnsTitle(): Promise<string>

- Gets the value of `columnsTitle` property. The text for the title on the column edge.

  #### Returns Promise<string>

  The value of `columnsTitle` property.

### getCountLabel

- getCountLabel(): Promise<null>

- Gets the value of `countLabel` property. A function that returns custom text for the cell count labels.

  #### Returns Promise<null>

  The value of `countLabel` property.

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getCssValue

### getDataTransferOptions

- getDataTransferOptions(): Promise<DataTransferOptions>

- Gets the value of `dataTransferOptions` property. Specifies data transfer features.

  #### Returns Promise<DataTransferOptions>

  The value of `dataTransferOptions` property.

### getDnd

- getDnd(): Promise<Dnd>

- Gets the value of `dnd` property. Provides support for HTML5 Drag and Drop events. See the Help documentation for more information.

  #### Returns Promise<Dnd>

  The value of `dnd` property.

### getGroupAttributes

- getGroupAttributes(): Promise<string[]>

- Gets the value of `groupAttributes` property. An array of attributes for styling the group nodes.

  #### Returns Promise<string[]>

  The value of `groupAttributes` property.

### getGroupBehavior

- getGroupBehavior(): Promise<string>

- Gets the value of `groupBehavior` property. Specifies how nodes should be grouped.

  #### Returns Promise<string>

  The value of `groupBehavior` property.

### getHiddenCategories

- getHiddenCategories(): Promise<string[]>

- Gets the value of `hiddenCategories` property. An array of category strings used for filtering. Data items with any category matching an item in this array will be filtered.

  #### Returns Promise<string[]>

  The value of `hiddenCategories` property.

### getHighlightMatch

- getHighlightMatch(): Promise<string>

- Gets the value of `highlightMatch` property. The matching condition for the highlightedCategories property. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `highlightMatch` property.

### getHighlightedCategories

- getHighlightedCategories(): Promise<string[]>

- Gets the value of `highlightedCategories` property. An array of category strings used for highlighting. Data items matching categories in this array will be highlighted.

  #### Returns Promise<string[]>

  The value of `highlightedCategories` property.

### getHoverBehavior

- getHoverBehavior(): Promise<string>

- Gets the value of `hoverBehavior` property. Defines the behavior applied when hovering over data items.

  #### Returns Promise<string>

  The value of `hoverBehavior` property.

### getLabelTruncation

- getLabelTruncation(): Promise<string>

- Gets the value of `labelTruncation` property. Specifies node label truncation behavior. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `labelTruncation` property.

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from OjWebElement.getLocation

### getMaximizedColumn

- getMaximizedColumn(): Promise<string>

- Gets the value of `maximizedColumn` property. The id of the column to be maximized.

  #### Returns Promise<string>

  The value of `maximizedColumn` property.

### getMaximizedRow

- getMaximizedRow(): Promise<string>

- Gets the value of `maximizedRow` property. The id of the row to be maximized.

  #### Returns Promise<string>

  The value of `maximizedRow` property.

### getNodes

- getNodes(): Promise<null | Nodes[]>

- Gets the value of `nodes` property. The list of nodes. Also accepts a Promise for deferred data rendering.

  #### Returns Promise<null | Nodes[]>

  The value of `nodes` property.

### getOtherColor

- getOtherColor(): Promise<string>

- Gets the value of `otherColor` property. The color for the "other" group nodes. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `otherColor` property.

### getOtherThreshold

- getOtherThreshold(): Promise<number>

- Gets the value of `otherThreshold` property. The threshold for aggregating nodes into an "other" group node. See the Help documentation for more information.

  #### Returns Promise<number>

  The value of `otherThreshold` property.

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjWebElement.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from OjWebElement.getRect

### getRows

- getRows(): Promise<null | Rows[]>

- Gets the value of `rows` property. The list of rows. Also accepts a Promise for deferred data rendering.

  #### Returns Promise<null | Rows[]>

  The value of `rows` property.

### getRowsTitle

- getRowsTitle(): Promise<string>

- Gets the value of `rowsTitle` property. The text for the title on the row edge.

  #### Returns Promise<string>

  The value of `rowsTitle` property.

### getSelection

- getSelection(): Promise<any[]>

- Gets the value of `selection` property. Specifies the ids of the selected nodes.

  #### Returns Promise<any[]>

  The value of `selection` property.

### getSelectionMode

- getSelectionMode(): Promise<string>

- Gets the value of `selectionMode` property. Specifies the selection behavior on the NBox. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `selectionMode` property.

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from OjWebElement.getSize

### getStyleDefaults

- getStyleDefaults(): Promise<StyleDefaults>

- Gets the value of `styleDefaults` property. An object defining the style defaults for this NBox.

  #### Returns Promise<StyleDefaults>

  The value of `styleDefaults` property.

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getText

### getTooltip

- getTooltip(): Promise<Tooltip>

- Gets the value of `tooltip` property. An object containing an optional callback function for tooltip customization.

  #### Returns Promise<Tooltip>

  The value of `tooltip` property.

### getTouchResponse

- getTouchResponse(): Promise<string>

- Gets the value of `touchResponse` property. Specifies configuration options for touch and hold delays on mobile devices. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `touchResponse` property.

  #### Deprecated

  Since 18.0.0. This attribute is deprecated and no longer recommended in the Redwood Design system. The "auto" value behavior will be applied instead.

### getTrackResize

- getTrackResize(): Promise<string>

- Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `trackResize` property.

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjWebElement.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjWebElement.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.sendKeys

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjWebElement.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjWebElement.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjWebElement.whenReady

Generated using TypeDoc